//+------------------------------------------------------------------+
//|                                       Ind-WSO+WRO+Trend Line.mq4 |
//|                                      http://www.expert-mt4.nm.ru |
//|                                                                  |
//|                                                    TrendLine.mq4 |
//|                                                   raff1410@o2.pl |
//+------------------------------------------------------------------+
#property indicator_chart_window

//---- input parameters
extern int    TPeriod       = 18;
extern int    TLimit        = 150;

extern bool   AutoAdjust    = true;
extern int    AutoTimeframe = 240;
extern int    TimeFrame     = 0;

extern bool   HorizontalLines    = true;

extern color  Support       = Blue;
extern color  Resistance    = Maroon;

extern bool   SoundAlert    = false;
extern int    AlertPipRange = 10;
extern string AlertWav      = "alert.wav";
extern string UniqueID      = "TrendLine_";
//---- 
int nPeriod, Limit, cnt, i, NumOfObj, nCurBar = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   nPeriod=TPeriod;
   Limit=TLimit;
   TimeFrame = MathMax(TimeFrame,Period());
   if (TimeFrame<AutoTimeframe)
   {
      int AutoFactor = AutoTimeframe/TimeFrame;
      nPeriod=TPeriod*AutoFactor;
      Limit=TLimit*AutoFactor;
   }
   NumOfObj=10;
   if (HorizontalLines) NumOfObj=24;
   color SetColor=Support;
   int   SetObject = OBJ_TREND;
   for(cnt=1; cnt<=NumOfObj; cnt++)
   {
      if (cnt>5) SetColor=Resistance;
      if (cnt>10) {SetColor=Support; SetObject=OBJ_HLINE;}
      if (cnt>16) SetColor=Resistance;
      ObjectCreate(UniqueID+cnt,SetObject,0,0,0,0,0);
      ObjectSet(UniqueID+cnt,OBJPROP_COLOR,SetColor);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   for(cnt=1; cnt<=24; cnt++)
      {
      ObjectDelete(UniqueID+cnt);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- TODO: add your code here
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;

   if(Bars<Limit) Limit=Bars-nPeriod;
   for(nCurBar=Limit; nCurBar>0; nCurBar--)
   {
     if(iLow(NULL,TimeFrame,nCurBar+(nPeriod-1)/2) == iLow(NULL,TimeFrame,iLowest(NULL,TimeFrame,MODE_LOW,nPeriod,nCurBar)))
     {
       s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=iLow(NULL,TimeFrame,nCurBar+(nPeriod-1)/2);
       st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2;
     }
     if(iHigh(NULL,TimeFrame,nCurBar+(nPeriod-1)/2) == iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,nPeriod,nCurBar)))
     {
       r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=iHigh(NULL,TimeFrame,nCurBar+(nPeriod-1)/2);
       rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;
     }
   }
//---- Move Object
   ObjectMove(UniqueID+"1",1,Time[st1],s1);
   ObjectMove(UniqueID+"1",0,Time[st2],s2);
   ObjectMove(UniqueID+"2",1,Time[st2],s2);
   ObjectMove(UniqueID+"2",0,Time[st3],s3);
   ObjectMove(UniqueID+"3",1,Time[st3],s3);
   ObjectMove(UniqueID+"3",0,Time[st4],s4);
   ObjectMove(UniqueID+"4",1,Time[st4],s4);
   ObjectMove(UniqueID+"4",0,Time[st5],s5);
   ObjectMove(UniqueID+"5",1,Time[st5],s5);
   ObjectMove(UniqueID+"5",0,Time[st6],s6);
   ObjectMove(UniqueID+"6",1,Time[rt1],r1);
   ObjectMove(UniqueID+"6",0,Time[rt2],r2);
   ObjectMove(UniqueID+"7",1,Time[rt2],r2);
   ObjectMove(UniqueID+"7",0,Time[rt3],r3);
   ObjectMove(UniqueID+"8",1,Time[rt3],r3);
   ObjectMove(UniqueID+"8",0,Time[rt4],r4);
   ObjectMove(UniqueID+"9",1,Time[rt4],r4);
   ObjectMove(UniqueID+"9",0,Time[rt5],r5);
   ObjectMove(UniqueID+"10",1,Time[rt5],r5);
   ObjectMove(UniqueID+"10",0,Time[rt6],r6);
   if (HorizontalLines)
   {
      ObjectMove(UniqueID+"11",0,Time[st1],s1);
      ObjectMove(UniqueID+"12",0,Time[st2],s2);
      ObjectMove(UniqueID+"13",0,Time[st3],s3);
      ObjectMove(UniqueID+"14",0,Time[st4],s4);
      ObjectMove(UniqueID+"15",0,Time[st5],s5);
      ObjectMove(UniqueID+"16",0,Time[st6],s6);
      ObjectMove(UniqueID+"17",0,Time[rt1],r1);
      ObjectMove(UniqueID+"18",0,Time[rt2],r2);
      ObjectMove(UniqueID+"19",0,Time[rt3],r3);
      ObjectMove(UniqueID+"20",0,Time[rt4],r4);
      ObjectMove(UniqueID+"21",0,Time[rt5],r5);
      ObjectMove(UniqueID+"22",0,Time[rt6],r6);
   }
//----
   double val;
   bool soundOn=true;
   for(cnt=1; cnt<=NumOfObj; cnt++)
    {
      ObjectSet(UniqueID+cnt,OBJPROP_WIDTH,1);
      val=ObjectGetValueByShift(UniqueID+cnt, 0);
      if (cnt>10) val=ObjectGet(UniqueID+cnt, OBJPROP_PRICE1);
      if(Bid-AlertPipRange*Point <= val && Bid+AlertPipRange*Point >= val)
      {
         ObjectSet(UniqueID+cnt,OBJPROP_WIDTH,2);
         if (SoundAlert && soundOn) {PlaySound(AlertWav); soundOn=false;}
      }
    }
//----
   return(0);
  }
//--------------------------------------------------+  